/* Chip type               : ATiny13
Program type            : Application
AVR Core Clock frequency: 9,600000 MHz
*****************************************************/

#include <tiny13.h>
//#include <delay.h>          //  

#define secundes 10    //    
#define timDiv   600    // ~600     
#define button_delay 2 //  ()

#define longkey   0xFF    //  -     


unsigned int    timCount = 0;    //   
unsigned int    systemClock = 0; //   
unsigned char   count = 0;      //   

//bit     KeyEXE;                     //  
//bit     BACKLIGHT_on;                     //   


#define SBIT(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define CBIT(ADDRESS,BIT)  ((ADDRESS) &= ~(1<<(BIT)))
#define KeyPress    (!PINB.1)       // 
#define led_on      (PORTB.0)      // 

#define u8 unsigned char

struct{
	u8 KeyEXE:1;		//  
	u8 BACKLIGHT_on:1	//   
	u8 bit2:1;
	u8 bit3:1;
	u8 bit4;1;
	u8 bit5:1;
	u8 bit6:1;
	u8 bit7:1;
} M;

 void    BACKLIGHT_on_off(void);
 


// 
void    key_scan(void)
{

   
    if  KeyPress                //  .        
    {                            
            count++;          //  .  ,        
            if  (count>longkey) //  
            {                                
               BACKLIGHT_on_off();
               count--;        // ""          
            }                   //
         
        else                    
        {   
            count=0;         //   
        }                       //  
        
       systemClock = 0;        //   .
    }

    else               //    ...
        {#asm("sleep")}    // ... ""
}

/// 
void    BACKLIGHT_on_off(void)
{
    if  (BACKLIGHT_on)                //   ()
    {   
         
        led_on = 0;// 
        BACKLIGHT_on = 0; //    
  
        systemClock = secundes - button_delay;    //     
    }
    else                        //   - 
    {   
        
        led_on = 1;      //  
        BACKLIGHT_on = 1;  //      
    }                                               
}



void I_Want_Sleep(void)
{
    systemClock = 0;
    TCCR0B=0;                           //Disable timer
    MCUCR=0x30;                         //PowerDown Mode interrupt by level
    GIMSK=0x40;                         //Enable External Interrupt-0
    #asm("sleep")           //   
}  


 //    INT0// Time 0 overflow interrupt service routine
//   8 mS
interrupt [TIM0_OVF] void Time0_ovf_isr(void)
{ 
    KeyEXE = 1;          //   
    timCount++;
    if (timCount > timDiv) 
    {
        timCount=0; systemClock++;
    }
}
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
    GIMSK=0x00;  //Disable External Interrupt-0 
        //TCCR0A |= ((1<<COM0A1)|(1<<COM0A0)); //,    ?
    TCCR0B=(0<<CS02)|(1<<CS01)|(1<<CS00);//CLK/64
        //TCCR0B=(0<<CS01)|(1<<CS01)|(0<<CS00);//CLK/8 (,    CPU  600)
         MCUCR=0x20; //Idle Mode interrupt by level (  )
}



void main(void)
{
// Input/Output Ports initialization
PORTB=0x02;   // . PULL UP     !
DDRB=(1<<led_on);
// Time/Counter 0 initialization
// Clock source: System Clock/64
// Clock value: 585.9 Hz
TCNT0=0x00;                
//TCCR0A=0xC3;//Fast PWM (Mode 3) Set OC0B on Compare Match, clear OC0B at TOP

TCCR0A = (1<<WGM01) | (1<<WGM00); //    Fast PWM,   ,  8 bit timer/counter register description
//TCCR0A |= ((1<<COM0A1)|(1<<COM0A0)); //    OC0B,  8 bit timer/counter register description
TCCR0B=(0<<CS02)|(1<<CS01)|(1<<CS00);//CLK/64
//TCCR0B=(0<<CS01)|(1<<CS01)|(0<<CS00);//CLK/8 (,    CPU  600)

// Time(s)/Counter(s) Interrupt(s) initialization
TIMSK0=0x02;//Timer Overflow Interrupt

// Global enable interrupts
#asm("sei")

I_Want_Sleep(); //   PowerDown

while (1)
      {   
            if  (KeyEXE)
            {  
                key_scan();
            } 
            //systemClock++; //    
/*             .
   ,  ,      ,   
 . */

            if  (systemClock > secundes)
            {   
                            
                I_Want_Sleep(); //   PowerDown 
                
            }
      }
}
